'''
Created on Oct 20, 2023

@author: lagarass
'''


class CogFormat:
    def __init__(self, setting):
        self.setting = setting.get_settings()

    def getCompressAlgorithm(self):
        return self.setting.cog.parameters.compress

    def getPredictor(self) -> bool:
        return self.setting.cog.parameters.predictor

    def getOverviews(
        self,
    ):
    # gives errors in lower python versions
    #-> (
    #    list[int] | None
    #):  # type found in https://cogeotiff.github.io/rio-cogeo/Advanced/
        return self.setting.cog.parameters.overviews

    def getBlocksize(self) -> int:
        return self.setting.cog.parameters.blocksize

    def to_dict(self):
        return {
            key.lower(): value
            for key, value in self.setting.cog.parameters.items()
        }


# settings defined on cfg/settings.toml

"""
##FILE_FORMAT##
[cog.parameters]
COMPRESS    = "ZSTD"
PREDICTOR   = "YES"
OVERVIEWS   = "None"
BLOCKSIZE   = 512
"""
