'''
Created on Nov 5, 2023

@author: demunckd
'''


import json

from cgls_cpe.config.configuration import Configuration
from cgls_cpe.storage import remote_storage
from cgls_cpe.storage.implementation.s3_api import S3Api

s3_api = None

BUCKET_SANDBOX_NAME='cgl-sandbox'
BUCKET_REF_DATA_NAME='cgl-reference-data'

TEST_INPUT_NAME='input'
TEST_RESULT_NAME='result'

TEST_UNIT_TEST_NAME='unit-tests'
TEST_INTEGRATION_TEST_NAME='integration-tests'

#TODO: return transparantly locations also with STAG/PROD prefix depending on environment if they exist


def get_url_ref_data_input(path):
    return 's3://' + BUCKET_REF_DATA_NAME + '/' + TEST_INPUT_NAME + '/' + path

def get_url_ref_data_input_unit_tests(module:str,unittest_name:str, unittest_method:str, filename:str='input_data.pkl'):
    return 's3://' + BUCKET_REF_DATA_NAME + '/' + TEST_INPUT_NAME + '/' + TEST_UNIT_TEST_NAME + '/' + module + '/' + unittest_name + '/' + unittest_method + '/' + filename

def get_url_ref_data_result(path):
    return 's3://' + BUCKET_REF_DATA_NAME + '/' + TEST_RESULT_NAME + '/' + path

def get_url_ref_data_result_unit_tests(path):
    return get_url_ref_data_result(TEST_UNIT_TEST_NAME + '/' + path)  

def get_url_ref_data_result_integration_tests(path):
    return get_url_ref_data_result(TEST_INTEGRATION_TEST_NAME + '/' + path)  


def get_url_sandbox_unit_test(path):
    return 's3://' + BUCKET_SANDBOX_NAME + '/' +TEST_UNIT_TEST_NAME + '/' + path


def __init_permission_for_externals():
        Configuration().force_env_production()
        policy_json = Configuration().get_settings().s3_perm_cglops_and_external_to_cglops_prod
        for year in range(2025,2026):
            custom_policy = json.dumps(policy_json)
            for i in range(1, 13):
                month = f"{i:02}"
                print("year - month " + str(year) + str(month))
                try:
                    remote_storage.__get_s3_api().set_policy_on_bucket('prod-sen3-toc-1-' + str(year) + '-' + month, custom_policy)
                except:
                    print("failed - bucket does not exist?")


def __init_lsp_buckets():
    for year in range(2019, 2030):
        #create it
        remote_storage.upload_single_file_to_remote_path('/tmp/Readme.txt','s3://prod-sen3-tocr-lsp-' + str(year) + '/Readme.txt')
        #to 
        policy_json = Configuration().get_settings().s3_perm_cglops_to_cglops_prod
        custom_policy = json.dumps(policy_json)
        remote_storage.__get_s3_api().set_policy_on_bucket('prod-sen3-tocr-lsp-' + str(year), custom_policy)


def __init_permission():
        policy_json = Configuration().get_settings().s3_perm_sandbox
        custom_policy = json.dumps(policy_json)
        
        remote_storage.__get_s3_api().set_policy_on_bucket(BUCKET_SANDBOX_NAME, custom_policy)
        
        policy_json = Configuration().get_settings().s3_perm_reference_data
        custom_policy = json.dumps(policy_json)
        remote_storage.__get_s3_api().set_policy_on_bucket(BUCKET_REF_DATA_NAME, custom_policy)

#__init_lsp_buckets()
#__init_permission_for_externals()
#__init_lsp_buckets()
        